/*****************************************************************************
**
** program_ugnx4_get_linear_assembly_release_3.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/



//   
//1.     
//2.    
//3. - 
//4.        
//5.     ,     
//
//  ?
//1.        RGB(Red-Blue-Green)
//2.      
//3.      RGB   RGB
//4.    RGB        
//5.       
//6.         



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>
#include <uf_ugmgr.h>

static	FILE*	prterr;
static	int		errorCode;

static	tag_t			parent_part;
static	uf_list_p_t		list;
static	int				part_units;


//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}


//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		fflush(prterr);
		errorCode=0;
	}
}


//   
static	int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}



static	void	cycle_components(tag_t	object)
{
	int		list_count,child_count,i;
	tag_t*	child_components;
	bool	not_item;
	tag_t	list_item;


	//   <object>
	//   <child_components>
	//    <chil_count>
	child_count=UF_ASSEM_ask_part_occ_children(object,&child_components);

	if(child_count==0)//  ,    
	{
		//   <list_count>
		errorCode=UF_MODL_ask_list_count ( list, &list_count );PRTERR;
		
		not_item=TRUE;

		//    
		for(i=0;i<list_count;i++)
		{
			errorCode=UF_MODL_ask_list_item ( list,i,&list_item );PRTERR;
			if(list_item==object)
			{
				not_item=FALSE;
				break;
			}
		}
		if(not_item)
		{
			errorCode=UF_MODL_put_list_item ( list, object );
			PRTERR;
		}

	}
	else//   , 
		//       
	{
		for(i=0;i<child_count;i++)
			cycle_components(child_components[i]);
		UF_free(child_components);
	}

term:
	return;
}





// 
int	do_it(void)
{

	//    
	int		old_cto_count;
	double	old_clr_values[220][3];

	{
		int		i;
		int		clr_model=UF_DISP_rgb_model;
		char*	color_name;


		errorCode=UF_DISP_ask_color_count(&old_cto_count);PRTERR;
		//fprintf(prterr,"\n\told_cto_count=%d\n",old_cto_count);

		for(i=0;i<old_cto_count;i++)
		{
			errorCode=UF_DISP_ask_color(i,clr_model,&color_name,old_clr_values[i]);PRTERR;
			UF_free(color_name);

		}
	}



	


	tag_t*	selected_components;
	int		selected_count;

label_select:
//   
	{

		// UF_UI_select_with_class_dialog
		//       
		char*	message="  ";
		char*	title=" ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		void*	user_data=NULL;
		int		i,response,count;
		tag_t*	object;

		

		//  
		errorCode=UF_UI_select_with_class_dialog
			(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		PRTERR(__LINE__);
		
		switch(response)
		{

		case UF_UI_BACK:	goto label_select;
		case UF_UI_CANCEL:	goto term;
		case UF_UI_OK:		break;

		}

		//  
		if(count==0)
		{
			uc1601("  !",1);
			goto label_select;
		}
		
		selected_components=object;
		selected_count=count;

		//  
		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR(__LINE__);
		}
	}






	//   
	//   
	//   
	{

		int	i;

		//    		
		errorCode=UF_MODL_create_list ( &list );PRTERR;


		for(i=0;i<selected_count;i++)
			cycle_components(selected_components[i]);


	}



    




	int		semaphor,NEW=0,OPEN=1;
	logical	is_active;

	//display selection menu
	{

		char*	cp1=" NEW  OPEN ";
		int		menu_item;
		int		ip2=1;
		int		ip4=2;
		char	cp3[][38]={"new file","open file"};

		menu_item=uc1603(cp1,ip2,cp3,ip4);
		switch(menu_item)
		{
		case 1:	goto label_select;
		case 2:	goto term;
		case 5: semaphor=NEW;break;
		case 6: semaphor=OPEN;break;
		case 19:
			uc1601("disallowed state, unable to bring up dialog",1);
			fprintf(prterr,"disallowed state, unable to bring up dialog");
			fprintf(prterr,"\t line=%d\n",__LINE__);
			goto term;

		}
		
		//Checks to see if an NX/Manager process is
		//active. It returns true if NX/Manager is active.
		errorCode=UF_is_ugmanager_active ( &is_active );PRTERR;

	}



	char	file_name[ 256 + 1 ]={""}; 
	char*	part_file_type;
	tag_t	part_tag;

	char	part_number[300]; 
	char	part_revision[10]={"A"}; 
	char*	part_file_name="aa"; 
	char	encoded_name[MAX_FSPEC_SIZE+1];
	
	char	ch='/';
	char*	pdest;
	int		result;

	//create a new file
	if(semaphor==NEW)
	{

		
		char	template_name[ 256 + 1 ];
		
		int		response;
		




		if(is_active)
		{
			
			errorCode=UF_UI_ugmgr_ask_create_part_name 
			( part_number,&part_file_type,template_name,&response);PRTERR;

			switch(response)
			{
				case UF_UI_OK:		break;
				case UF_UI_CANCEL:	goto term;
			}

			//fprintf(prterr,"\n	part_number = %s \n",part_number);
			pdest=strchr(part_number,ch);
			result=(int)(pdest-part_number);
			strcpy_s(part_number,pdest+1);
			//fprintf(prterr,"\n	part_number = %s \n",part_number);
			pdest=strchr(part_number,ch);
			strcpy_s(part_revision,pdest+1);
			//fprintf(prterr,"\n	part_revision = %s \n",part_revision);
			strcpy_s(pdest,1,"");
			//fprintf(prterr,"\n	part_number = %s \n",part_number);
	
			errorCode=UF_UGMGR_encode_part_filename 
			( part_number,part_revision,"master",part_file_name,encoded_name);PRTERR;

			errorCode=UF_PART_new(encoded_name,1,&part_tag);PRTERR;


		}
		else
		{
			
			errorCode=UF_UI_create_part 
			(NULL,file_name,&part_units,&part_tag,&response);PRTERR;
			
			switch(response)
			{
			case UF_UI_OK:		break;
			case UF_UI_CANCEL:	goto term;
			}

		}

	}



	//open file
	if(semaphor==OPEN)
	{
		char		file_name[300]={""};
		logical		unused;
		int			response;
		tag_t		part;

		UF_PART_load_status_t	error_status;

		errorCode=UF_UI_open_part
		(NULL,file_name,&unused,&part,&response,&error_status);
		PRTERR;

		switch(response)
		{
		case UF_UI_OK:		break;
		case UF_UI_CANCEL:	goto term;
		}

		part_tag=part;

	}


	int	part_units;

	//Returns a value indicating whether the part is in English or metric units.
	errorCode=UF_PART_ask_units ( part_tag, &part_units );PRTERR;
	if(part_units==UF_PART_METRIC)
		fprintf(prterr,"\n\t     ====== \n");
	else if(part_units==UF_PART_ENGLISH)
		fprintf(prterr,"\n\t     ====== \n");







	//create other assembly -----------------------------------------
	{
		int
			i;
		char
			part_name[MAX_FSPEC_SIZE+1],
			refset_name[MAX_ENTITY_NAME_SIZE+1],
			instance_name[MAX_ENTITY_NAME_SIZE+1];
		double
			origin[3],
			csys_matrix[9],
			transform[4][4];
		UF_PART_load_status_t
			error_status;
		tag_t
			new_instance;

		int		list_count;
		tag_t	list_item;
		tag_t	part_occ_tag;
		
	
		UF_OBJ_disp_props_t	disp_props;

		int		clr_model=UF_DISP_rgb_model;
		int		clr_cmp_mtd=UF_DISP_CCM_EUCLIDEAN_DISTANCE;
		int		clr_num;

		char	name_item[31];
		double	name_origin[3];


		int		j,step;
		char	status_text[50];



		errorCode=UF_MODL_ask_list_count ( list, &list_count );PRTERR;
		step=list_count/100;
		j=0;

		for(i=0;i<list_count;i++)
		{
			

			j++;
			if(j>=step)
			{
				//message
				sprintf_s(status_text,"   %03d%%",100*i/list_count);
				errorCode=UF_UI_set_prompt (status_text);PRTERR
				j=0;
			}

			
			errorCode=UF_MODL_ask_list_item ( list,i,&list_item );PRTERR;

			//  -
			errorCode=UF_OBJ_ask_name(list_item,name_item);PRTERR;
			
			//   
			errorCode=UF_OBJ_ask_name_origin(list_item,name_origin);PRTERR;

			errorCode=UF_OBJ_ask_display_properties(list_item,&disp_props);PRTERR;

			clr_num=disp_props.color;
			


			errorCode=UF_ASSEM_ask_component_data
			(list_item,part_name,refset_name,instance_name,
			origin,csys_matrix,transform);PRTERR;
						

			if(strcmp(refset_name,"None")==0)
				strcpy_s(refset_name,1,"");

			errorCode=UF_ASSEM_add_part_to_assembly
			(part_tag,part_name,refset_name,instance_name,
			origin,csys_matrix,0,&new_instance,
			&error_status);PRTERR;

			//      part_occ 
			part_occ_tag=UF_ASSEM_ask_part_occ_of_inst(NULL, new_instance );

			
			//   
			errorCode=UF_OBJ_set_color(part_occ_tag,clr_num);PRTERR;

			//   
			errorCode=UF_OBJ_set_name(part_occ_tag,name_item);PRTERR;

			//    
			errorCode=UF_OBJ_set_name_origin(part_occ_tag,name_origin);PRTERR;

		}

	}//--- create other assembly -----------------------------------------

	//errorCode=UF_PART_save ( );PRTERR;






	goto term;
term:
	return errorCode;

}








/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;

	
	time(&start_time);	// 

	//     D:
	if(fopen_s(&prterr,"D:\\prterr.txt","w")==0)
		goto label_clock;

	//     C:\\temp
	if(fopen_s(&prterr,"C:\\temp\\prterr.txt","w")==0)
		goto label_clock;

	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	localtime_s(&newtime,&aclock);
	fprintf(prterr,"\n <get_linear_assembly>	HAS STARTED		line=%d\n",__LINE__);
	

	char	asctime_string[100];
	asctime_s(asctime_string,&newtime);

	fprintf(prterr,"\n    :	%s\n\n",asctime_string);

	errorCode=UF_initialize();PRTERR;


	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  ",1);
		fprintf(prterr,"\n	   	line=%d\n",__LINE__);
		goto term;
	}

	

	//Returns a value indicating whether the part is in English or metric units.
	errorCode=UF_PART_ask_units ( parent_part, &part_units );PRTERR;
	if(part_units==UF_PART_METRIC)
		fprintf(prterr,"\n\t     ====== \n");
	else if(part_units==UF_PART_ENGLISH)
		fprintf(prterr,"\n\t     ====== \n");

	

	*returnCode=do_it();

	returnCode=0;

	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <get_linear_assembly>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);
		
	
	fflush(prterr);
	fclose(prterr);
	return;
}


/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
